<?php
class ControllerShippingTNTBe extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('shipping/tnt_be');

		$this->document->title = $this->language->get('heading_title');

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->model_setting_setting->editSetting('tnt_be', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect(HTTPS_SERVER . 'index.php?route=extension/shipping&token=' . $this->session->data['token']);
		}

		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['text_none'] = $this->language->get('text_none');
		$this->data['text_yes'] = $this->language->get('text_yes');
		$this->data['text_no'] = $this->language->get('text_no');
//		$this->data['text_letter'] = $this->language->get('text_letter');
		$this->data['text_secure_be'] = $this->language->get('text_secure_be');
		$this->data['text_extra_secure_be'] = $this->language->get('text_extra_secure_be');
		$this->data['text_extra_secure_nelux'] = $this->language->get('text_extra_secure_nelux');
		$this->data['text_extra_secure_eu'] = $this->language->get('text_extra_secure_eu');
		$this->data['entry_service'] = $this->language->get('entry_service');
		$this->data['entry_display_weight'] = $this->language->get('entry_display_weight');
		$this->data['entry_display_insurance'] = $this->language->get('entry_display_insurance');
		$this->data['entry_display_time'] = $this->language->get('entry_display_time');
		$this->data['entry_weight_class'] = $this->language->get('entry_weight_class');
		$this->data['entry_tax'] = $this->language->get('entry_tax');
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

		$this->data['tab_general'] = $this->language->get('tab_general');

		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

		$this->document->breadcrumbs = array();

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=common/home&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('text_home'),
      		'separator' => FALSE
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=extension/shipping&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('text_shipping'),
      		'separator' => ' :: '
   		);

   		$this->document->breadcrumbs[] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=shipping/tnt_be&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('heading_title'),
      		'separator' => ' :: '
   		);

		$this->data['action'] = HTTPS_SERVER . 'index.php?route=shipping/tnt_be&token=' . $this->session->data['token'];

		$this->data['cancel'] = HTTPS_SERVER . 'index.php?route=extension/shipping&token=' . $this->session->data['token'];

		if (isset($this->request->post['tnt_be_secure_be'])) {
			$this->data['tnt_be_secure_be'] = $this->request->post['tnt_be_secure_be'];
		} else {
			$this->data['tnt_be_secure_be'] = $this->config->get('tnt_be_secure_be');
		}

		if (isset($this->request->post['tnt_be_extra_secure_be'])) {
			$this->data['tnt_be_extra_secure_be'] = $this->request->post['tnt_be_extra_secure_be'];
		} else {
			$this->data['tnt_be_extra_secure_be'] = $this->config->get('tnt_be_extra_secure_be');
		}

		if (isset($this->request->post['tnt_be_extra_secure_nelux'])) {
			$this->data['tnt_be_extra_secure_nelux'] = $this->request->post['tnt_be_extra_secure_nelux'];
		} else {
			$this->data['tnt_be_extra_secure_nelux'] = $this->config->get('tnt_be_extra_secure_nelux');
		}

		if (isset($this->request->post['tnt_be_extra_secure_eu'])) {
			$this->data['tnt_be_extra_secure_eu'] = $this->request->post['tnt_be_extra_secure_eu'];
		} else {
			$this->data['tnt_be_extra_secure_eu'] = $this->config->get('tnt_be_extra_secure_eu');
		}

		if (isset($this->request->post['tnt_be_display_weight'])) {
			$this->data['tnt_be_display_weight'] = $this->request->post['tnt_be_display_weight'];
		} else {
			$this->data['tnt_be_display_weight'] = $this->config->get('tnt_be_display_weight');
		}

		if (isset($this->request->post['tnt_be_display_insurance'])) {
			$this->data['tnt_be_display_insurance'] = $this->request->post['tnt_be_display_insurance'];
		} else {
			$this->data['tnt_be_display_insurance'] = $this->config->get('tnt_be_display_insurance');
		}

		if (isset($this->request->post['tnt_be_display_time'])) {
			$this->data['tnt_be_display_time'] = $this->request->post['tnt_be_display_time'];
		} else {
			$this->data['tnt_be_display_time'] = $this->config->get('tnt_be_display_time');
		}

		if (isset($this->request->post['tnt_be_weight_class'])) {
			$this->data['tnt_be_weight_class'] = $this->request->post['tnt_be_weight_class'];
		} else {
			$this->data['tnt_be_weight_class'] = $this->config->get('tnt_be_weight_class');
		}

		$this->load->model('localisation/weight_class');

		$this->data['weight_classes'] = $this->model_localisation_weight_class->getWeightClasses();

		if (isset($this->request->post['tnt_be_tax_class_id'])) {
			$this->data['tnt_be_tax_class_id'] = $this->request->post['tnt_be_tax_class_id'];
		} else {
			$this->data['tnt_be_tax_class_id'] = $this->config->get('tnt_be_tax_class_id');
		}

		if (isset($this->request->post['tnt_be_geo_zone_id'])) {
			$this->data['tnt_be_geo_zone_id'] = $this->request->post['tnt_be_geo_zone_id'];
		} else {
			$this->data['tnt_be_geo_zone_id'] = $this->config->get('tnt_be_geo_zone_id');
		}

		if (isset($this->request->post['tnt_be_status'])) {
			$this->data['tnt_be_status'] = $this->request->post['tnt_be_status'];
		} else {
			$this->data['tnt_be_status'] = $this->config->get('tnt_be_status');
		}

		if (isset($this->request->post['tnt_be_sort_order'])) {
			$this->data['tnt_be_sort_order'] = $this->request->post['tnt_be_sort_order'];
		} else {
			$this->data['tnt_be_sort_order'] = $this->config->get('tnt_be_sort_order');
		}

		$this->load->model('localisation/tax_class');

		$this->data['tax_classes'] = $this->model_localisation_tax_class->getTaxClasses();

		$this->load->model('localisation/geo_zone');

		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		$this->template = 'shipping/tnt_be.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);

		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'shipping/tnt_be')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}
	}
}
?>