<?php
/**
 * Opencart 1.4.8 en 1.4.8.b tnt_be Post module
 * @version $Id$ = 1.4.8.b rc 1
 * 2010 Gerrit Bouweriks for Opencart
 */
class ModelShippingTNTBe extends Model {
	function getQuote($address) {
		$this->load->language('shipping/tnt_be');

		if ($this->config->get('tnt_be_status')) {
      		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('tnt_be_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");

      		if (!$this->config->get('tnt_be_geo_zone_id')) {
        		$status = TRUE;
      		} elseif ($query->num_rows) {
        		$status = TRUE;
      		} else {
        		$status = FALSE;
      		}
		} else {
			$status = FALSE;
		}


		// als subtotaal meer is als gratis verzending, schakel tnt_be module uit.

//		if ($address['iso_code_2'] == 'BE') {
//			if ($this->cart->getSubTotal() > $this->config->get('free_total')) {
//				$status = FALSE;
//			}
//		}
//


		if ($status) {

//			$method_data = array();

			$quote_data = array();

			$error= FALSE;

			$weight = $this->cart->getWeight();
			$max_weight = 0;

			$no_shipping = FALSE;



			// pakket post
			if ($status && ($this->config->get('tnt_be_secure_be') && $address['iso_code_2'] == 'BE')) {
				$cost = 0;
				$compensation = 0;

				$max_weight = 10;

				$rates = explode(',', '10:5.74'); //gewicht tot 500 gram is brievenpost

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {

						if (isset($data[1])) {
							$cost = $data[1];
						}
						break;
					}
				}


				$rates = explode(',', '10:0');

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$compensation = $data[1];
						}

						break;
					}
				}


				if ((float)$cost) {

					$title = $this->language->get('text_secure_be');

					if ($this->config->get('tnt_be_display_weight')) {

						$title .= ' (' . $this->language->get('text_weight') . ' ' . $this->weight->format($weight, $this->config->get('config_weight_class')) . ')';
					}

					if ($compensation > 0) {

						if ($this->config->get('tnt_be_display_insurance') && (float)$compensation) {
						$title .= $this->language->get('text_insurance') . ' ' . $this->currency->format($compensation);
						}
					}

					if ($this->config->get('tnt_be_display_time')) {
						$title .= $this->language->get('text_eta_next_day');
					}

					$quote_data['secure_be'] = array(
						'id'           => 'tnt_be.secure_be',
						'title'        => $title,
						'cost'         => $cost,
						'tax_class_id' => $this->config->get('tnt_be_tax_class_id'),
						'text'         => $this->currency->format($this->tax->calculate($cost, $this->config->get('tnt_be_tax_class_id'), $this->config->get('config_tax')))
					);
				}
			}

			// extra secure Belgie
			if ($this->config->get('tnt_be_extra_secure_be') && $address['iso_code_2'] == 'BE') {
				$cost = 0;
				$compensation = 0;

				$max_weight = 30;

				$rates = explode(',', '10:6.57,30:7.43');

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$cost = $data[1];
						}

						break;
					}
				}

				$rates = explode(',', '10:50,30:50');

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$compensation = $data[1];
						}

						break;
					}
				}

				if ((float)$cost) {

					$title = $this->language->get('text_extra_secure_be');

					if ($this->config->get('tnt_be_display_weight')) {

						$title .= ' (' . $this->language->get('text_weight') . ' ' . $this->weight->format($weight, $this->config->get('config_weight_class')) . ')';
					}

					if ($this->config->get('tnt_be_display_insurance') && (float)$compensation) {
						$title .= $this->language->get('text_insurance') . ' ' . $this->currency->format($compensation);
					}

					if ($this->config->get('tnt_be_display_time')) {
						$title .= $this->language->get('text_eta_next_day');
					}

					$quote_data['extra_secure_be'] = array(
						'id'           => 'tnt_be.extra_secure_be',
						'title'        => $title,
						'cost'         => $cost,
						'tax_class_id' => $this->config->get('tnt_be_tax_class_id'),
						'text'         => $this->currency->format($this->tax->calculate($cost, $this->config->get('tnt_be_tax_class_id'), $this->config->get('config_tax')))
					);
				}
			}

			// extra secure Nederland en Luxemburg
			if ($this->config->get('tnt_be_extra_secure_nelux')) {
				$cost = 0;
				$compensation = 0;

				$max_weight = 30;

				$rates = array();

				$countries = explode(',', 'NL,LU');
				if (in_array($address['iso_code_2'], $countries)) {
					$rates = explode(',', '10:8.26,30:19.83');
				}

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$cost = $data[1];
						}

						break;
					}
				}

				$rates = array();

				$countries = explode(',', 'NL,LU');

				if (in_array($address['iso_code_2'], $countries)) {
					$rates = explode(',', '10:500,30:500');
				}

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$compensation = $data[1];
						}

						break;
					}
				}

				if ((float)$cost) {

					$title = $this->language->get('text_extra_secure_nelux');

					if ($this->config->get('tnt_be_display_weight')) {

						$title .= ' (' . $this->language->get('text_weight') . ' ' . $this->weight->format($weight, $this->config->get('config_weight_class')) . ')';
					}

					if ($this->config->get('tnt_be_display_insurance') && (float)$compensation) {
						$title .= $this->language->get('text_insurance') . ' ' . $this->currency->format($compensation);
					}

					if ($this->config->get('tnt_be_display_time')) {
						$title .= $this->language->get('text_eta_three');
					}

					$quote_data['extra_secure_nelux'] = array(
						'id'           => 'tnt_be.extra_secure_nelux',
						'title'        => $title,
						'cost'         => $cost,
						'tax_class_id' => $this->config->get('tnt_be_tax_class_id'),
						'text'         => $this->currency->format($this->tax->calculate($cost, $this->config->get('tnt_be_tax_class_id'), $this->config->get('config_tax')))
					);
				}
			}

//			Extra Secure Europa
//			Pakketten kunnen naar de volgende landen worden gestuurd, let op geen postbus
//			Bulgarije,Denemarken,Duitsland,Estland,Finland,Frankrijk,Hongarije,Ierland,
//			Italie,Letland,Litouwen,Oostenrijk,Polen,Portugal,Roemenie,Slovenie,Spanje,
//			Tjechie,Engeland,Zweden.

			if ($this->config->get('tnt_be_extra_secure_eu')) {
				$cost = 0;
				$compensation = 0;

				$max_weight = 30;


				$rates = array();

				$countries = explode(',', 'AT,BG,CZ,DK,DE,EE,ES,FI,FR,GB,HU,IE,IT,LT,LV,PL,PT,RO,SI,SK,SE');
				if (in_array($address['iso_code_2'], $countries)) {
					$rates = explode(',', '10:14,87,30:34,70');
				}

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$cost = $data[1];
						}

						break;
					}
				}

				$rates = array();

				$countries = explode(',', 'AT,BG,CZ,DK,DE,EE,ES,FI,FR,GB,HU,IE,IT,LT,LV,PL,PT,RO,SI,SK,SE');

				if (in_array($address['iso_code_2'], $countries)) {
					$rates = explode(',', '10:500,30:500');
				}

				foreach ($rates as $rate) {
					$data = explode(':', $rate);

					if ($data[0] >= $weight) {
						if (isset($data[1])) {
							$compensation = $data[1];
						}

						break;
					}
				}



				if ((float)$cost) {
					$title = $this->language->get('text_extra_secure_eu');

					if ($this->config->get('tnt_be_display_weight')) {
						$title .= ' (' . $this->language->get('text_weight') . ' ' . $this->weight->format($weight, $this->config->get('config_weight_class')) . ')';
					}

					if ($this->config->get('tnt_be_display_insurance') && (float)$compensation) {
						$title .= $this->language->get('text_insurance') . ' ' . $this->currency->format($compensation);
					}

					if ($this->config->get('tnt_be_display_time')) {
						$title .= $this->language->get('text_eta_five');
					}

					$quote_data['extra_secure_eu'] = array(
						'id'           => 'tnt_be.extra_secure_eu',
						'title'        => $title,
						'cost'         => $cost,
						'tax_class_id' => $this->config->get('tnt_be_tax_class_id'),
						'text'         => $this->currency->format($this->tax->calculate($cost, $this->config->get('tnt_be_tax_class_id'), $this->config->get('config_tax')))
					);
				}
			}

			// internationaal pakket post ROW1 en ROW2
			// voor deze landen is geen verzending mogelijk.
				$rates = array();

				$countries = explode(',', 'AL,AD,BY,BA,HR,FO,GI,GL,GG,IS,IM,JE,LI,MK,MD,ME,NO,SM,RS,CH,TR,UA,VA,
										   AF,AX,DZ,AS,AO,AI,AQ,AG,AR,AM,AW,AZ,BS,BH,BD,BB,BZ,BJ,BM,BT,BO,BW,BV,BR,IO,BN,BF,BI,
										   KH,CM,CA,CV,KY,CF,TD,CL,CN,CX,CC,CO,KM,CG,CD,CK,CR,CI,CU,DJ,DM,DO,EC,EG,SV,GQ,ER,ET,
										   FK,FJ,GF,PF,TF,GA,GM,GE,GH,GD,GP,GU,GT,GN,GW,GY,HT,HM,HN,HK,IN,ID,IR,IQ,IL,JM,JP,JO,
										   KZ,KE,KI,KP,KR,KW,KG,LA,LB,LS,LR,LY,MO,MG,MW,MY,MV,ML,MH,MQ,MR,MU,YT,MX,FM,MN,MS,MA,
										   MZ,MM,NA,NR,NP,AN,NC,NZ,NI,NE,NG,NU,NF,MP,OM,PK,PW,PS,PA,PG,PY,PE,PH,PN,PR,QA,RE,RU,
										   RW,BL,SH,KN,LC,MF,PM,VC,WS,ST,SA,SN,SC,SL,SG,SB,SO,ZA,GS,LK,SD,SR,SJ,SZ,SY,TW,TJ,TZ,
										   TH,TL,TG,TK,TO,TT,TN,TM,TC,TV,UG,AE,US,UM,UY,UZ,VU,VE,VN,VG,VI,WF,EH,YE,YU,ZM,ZW');

				if (in_array($address['iso_code_2'], $countries)) {
					$no_shipping = TRUE;

				}

		}

		$method_data = array();

		$title = $this->language->get('text_title');

		if ($weight > $max_weight) {
			$error = $this->language->get('over_weight');
		}

		if ($weight <= $max_weight) {
			$error = '';
		}

		if (intval($weight) == 0) {
			$error = $this->language->get('zero_weight');
		}

		if ($no_shipping) {
			$error = 'Sorry, we can not ship to your country, please contact us!';

		}


		if (!$quote_data) {
			$method_data = array(
				'id'         => 'tnt_be',
				'title'      => $title,
				'quote'      => $quote_data,
				'sort_order' => $this->config->get('tnt_be_sort_order'),
				'error'		 => $error
			);

		} else {
		$method_data = array(
				'id'         => 'tnt_be',
				'title'      => $title,
				'quote'      => $quote_data,
				'sort_order' => $this->config->get('tnt_be_sort_order'),
				'error'		 => FALSE
			);
		}

		return $method_data;
	}
}

?>